﻿namespace ProjectDumpTruck.Entities;

/// <summary>
/// Класс-сущность "Самосвал"
/// </summary>
public class EntityDumpTruck : EntityTruck
{
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }

    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color Additional2Color { get; private set; }

    /// <summary>
    /// Признак (опция) наличия кузова
    /// </summary>
    public bool Bodywork { get; private set; }

    /// <summary>
    /// Признак (опция) наличия тента
    /// </summary>
    public bool Awning { get; private set; }

    /// <summary>
    /// Инициализация полей объекта-класса самосвала
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="additional2Color">Дополнительный цвет</param>
    /// <param name="bodywork">Признак наличия кузова</param>
    /// <param name="awning">Признак наличия тента</param>

    public EntityDumpTruck(int speed, double weight, Color bodyColor, Color additionalColor, Color additional2Color, bool bodywork, bool awning) : base(speed, weight, bodyColor)
    {
        AdditionalColor = additionalColor;
        Additional2Color = additional2Color;
        Bodywork = bodywork;
        Awning = awning;
    }
}